diff mbox

xfstests: btrfs/003: regression test for subvol delete

Message ID 1376336447-20684-1-git-send-email-jbacik@fusionio.com (mailing list archive)
State Not Applicable
Headers show

Commit Message

Josef Bacik Aug. 12, 2013, 7:40 p.m. UTC
We were allowing users to delete their default subvolume, which is problematic.
This test is a regression test to make sure we don't let that happen in the
future.  Thanks,

Signed-off-by: Josef Bacik <jbacik@fusionio.com>
---
 tests/btrfs/003     |   64 +++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/btrfs/003.out |    2 +
 tests/btrfs/group   |    1 +
 3 files changed, 67 insertions(+), 0 deletions(-)
 create mode 100755 tests/btrfs/003
 create mode 100644 tests/btrfs/003.out

Comments

Eric Sandeen Aug. 12, 2013, 8:37 p.m. UTC | #1
On 8/12/13 2:40 PM, Josef Bacik wrote:
> We were allowing users to delete their default subvolume, which is problematic.
> This test is a regression test to make sure we don't let that happen in the
> future.  Thanks,
> 
> Signed-off-by: Josef Bacik <jbacik@fusionio.com>
> ---
>  tests/btrfs/003     |   64 +++++++++++++++++++++++++++++++++++++++++++++++++++
>  tests/btrfs/003.out |    2 +
>  tests/btrfs/group   |    1 +
>  3 files changed, 67 insertions(+), 0 deletions(-)
>  create mode 100755 tests/btrfs/003
>  create mode 100644 tests/btrfs/003.out
> 
> diff --git a/tests/btrfs/003 b/tests/btrfs/003
> new file mode 100755
> index 0000000..775322a
> --- /dev/null
> +++ b/tests/btrfs/003
> @@ -0,0 +1,64 @@
> +#! /bin/bash
> +# FS QA Test No. btrfs/003
> +#
> +# Regression test to make sure we can't delete the default subvol
> +#
> +#-----------------------------------------------------------------------
> +# Copyright (c) 2013 Fusion IO.  All Rights Reserved.
> +#
> +# This program is free software; you can redistribute it and/or
> +# modify it under the terms of the GNU General Public License as
> +# published by the Free Software Foundation.
> +#
> +# This program is distributed in the hope that it would be useful,
> +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +# GNU General Public License for more details.
> +#
> +# You should have received a copy of the GNU General Public License
> +# along with this program; if not, write the Free Software Foundation,
> +# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
> +#
> +#-----------------------------------------------------------------------
> +#
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +
> +status=1	# failure is the default!
> +
> +_cleanup()
> +{
> +	rm -f $tmp.*
> +}
> +
> +trap "_cleanup ; exit \$status" 0 1 2 3 15
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/filter
> +
> +# real QA test starts here
> +_supported_fs btrfs
> +_supported_os Linux
> +_require_scratch
> +
> +_scratch_mkfs > /dev/null 2>&1
> +_scratch_mount
> +
> +# This will be set to subvolid 256.  If this ever changes in the future for
> +# whatever reason we'll have to pull the subvolid out of the subvol list command
> +# but since it's a newly mkfs'ed fs we should be fine with this.

Is it that hard to just do it right the first time?  I'd rather see
it extracted properly... (perhaps with a helper?)

> +$BTRFS_UTIL_PROG sub create $SCRATCH_MNT/newvol >> $seqres.full 2>&1 \
> +	|| _fail "couldnt create subvol"
> +$BTRFS_UTIL_PROG sub set-default 256 $SCRATCH_MNT >> $seqres.full 2>&1 \
> +	|| _fail "couldn't set default"

you spelled "couldn't" with and without a ' - while you're at it.  ;)

> +$BTRFS_UTIL_PROG sub delete $SCRATCH_MNT/newvol >> $seqres.full 2>&1
> +[ $? -eq 0 ] && _fail "delete succeeded, should have failed"

Maybe umount & mount since that was the originally detected failure
(rather than simply relying on the exit status?)

-Eric

> +echo "Silence is golden"
> +status=0 ; exit
> diff --git a/tests/btrfs/003.out b/tests/btrfs/003.out
> new file mode 100644
> index 0000000..6895fc8
> --- /dev/null
> +++ b/tests/btrfs/003.out
> @@ -0,0 +1,2 @@
> +QA output created by 003
> +Silence is golden
> diff --git a/tests/btrfs/group b/tests/btrfs/group
> index 0733a1d..44b2f8e 100644
> --- a/tests/btrfs/group
> +++ b/tests/btrfs/group
> @@ -5,6 +5,7 @@
>  #
>  001 auto quick
>  002 auto quick
> +003 auto quick
>  254 auto quick
>  264 auto
>  265 auto
> 

--
To unsubscribe from this list: send the line "unsubscribe linux-btrfs" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
diff mbox

Patch

diff --git a/tests/btrfs/003 b/tests/btrfs/003
new file mode 100755
index 0000000..775322a
--- /dev/null
+++ b/tests/btrfs/003
@@ -0,0 +1,64 @@ 
+#! /bin/bash
+# FS QA Test No. btrfs/003
+#
+# Regression test to make sure we can't delete the default subvol
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2013 Fusion IO.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+
+status=1	# failure is the default!
+
+_cleanup()
+{
+	rm -f $tmp.*
+}
+
+trap "_cleanup ; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs btrfs
+_supported_os Linux
+_require_scratch
+
+_scratch_mkfs > /dev/null 2>&1
+_scratch_mount
+
+# This will be set to subvolid 256.  If this ever changes in the future for
+# whatever reason we'll have to pull the subvolid out of the subvol list command
+# but since it's a newly mkfs'ed fs we should be fine with this.
+$BTRFS_UTIL_PROG sub create $SCRATCH_MNT/newvol >> $seqres.full 2>&1 \
+	|| _fail "couldnt create subvol"
+$BTRFS_UTIL_PROG sub set-default 256 $SCRATCH_MNT >> $seqres.full 2>&1 \
+	|| _fail "couldn't set default"
+$BTRFS_UTIL_PROG sub delete $SCRATCH_MNT/newvol >> $seqres.full 2>&1
+[ $? -eq 0 ] && _fail "delete succeeded, should have failed"
+
+echo "Silence is golden"
+status=0 ; exit
diff --git a/tests/btrfs/003.out b/tests/btrfs/003.out
new file mode 100644
index 0000000..6895fc8
--- /dev/null
+++ b/tests/btrfs/003.out
@@ -0,0 +1,2 @@ 
+QA output created by 003
+Silence is golden
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 0733a1d..44b2f8e 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -5,6 +5,7 @@ 
 #
 001 auto quick
 002 auto quick
+003 auto quick
 254 auto quick
 264 auto
 265 auto